import com.cycling74.max.*;

class BGblues3 extends MaxObject {
	riff [] theRiffs = new riff[11];

	public BGblues3() {
		double q = 1.0;
		double e = 0.5;
		double dq = 1.5;
		double s = 0.25;

		// riff 0
		double [] parr0 = { 1.00, 1.07, 1.00, 1.07, 1.00, 1.09, 1.00, 1.09 };
		double [] darr0 = { q,    0.0,  e,    0.0,  q,    0.0,  e,    0.0  };
		double [] garr0 = { 0.6,  0.6,  1.0,  1.0,  0.6,  0.6,  1.0,  1.0  };
		String [] iarr0 = { "n",  "n",  "n",  "n",  "n",  "n",  "n",  "n", };
		theRiffs[0] = new riff(parr0.length, parr0, darr0, garr0, iarr0);

		// riff 1
		double [] parr1 = { 1.00, 1.10, 1.00, 1.10, 1.00, 1.09, 1.00, 1.09 };
		double [] darr1 = { q,    0.0,  e,    0.0,  q,    0.0,  e,    0.0  };
		double [] garr1 = { 0.6,  0.6,  1.0,  1.0,  0.6,  0.6,  1.0,  1.0  };
		String [] iarr1 = { "n",  "n",  "n",  "n",  "n",  "n",  "n",  "n", };
		theRiffs[1] = new riff(parr1.length, parr1, darr1, garr1, iarr1);

		// riff 2
		double [] parr2 = { 1.00, 1.07, 0.07, 0.10, 0.07, 0.10 };
		double [] darr2 = { q,    0.0,  e,    e,    e,    e,   };
		double [] garr2 = { 0.6,  0.6,  1.0,  1.0,  1.0,  1.0  };
		String [] iarr2 = { "n",  "n",  "n",  "n",  "n",  "n"  };
		theRiffs[2] = new riff(parr2.length, parr2, darr2, garr2, iarr2);

		// riff 3
		double [] parr3 = { 1.00, 1.07, 1.00, 1.03 };
		double [] darr3 = { q,    0.0,  e,    dq   };
		double [] garr3 = { 0.6,  0.6,  1.0,  1.0  };
		String [] iarr3 = { "n",  "n",  "n",  "v"  };
		theRiffs[3] = new riff(parr3.length, parr3, darr3, garr3, iarr3);

		// riff 4
		double [] parr4 = { 1.00, 1.07, 1.00, 0.10 };
		double [] darr4 = { q,    0.0,  e,    dq   };
		double [] garr4 = { 0.6,  0.6,  0.5,  1.0  };
		String [] iarr4 = { "n",  "n",  "n",  "b"  };
		theRiffs[4] = new riff(parr4.length, parr4, darr4, garr4, iarr4);

		// riff 5
		double [] parr5 = { 1.00, 1.03, 1.05, 1.06, 1.05, 1.03 };
		double [] darr5 = { e,    e,    e,    e,    e,    e    };
		double [] garr5 = { 1.0,  1.0,  1.0,  1.0,  1.0,  1.0  };
		String [] iarr5 = { "n",  "n",  "n",  "b",  "n",  "n"  };
		theRiffs[5] = new riff(parr5.length, parr5, darr5, garr5, iarr5);

		// riff 6
		double [] parr6 = { 2.10, 3.00, 3.00, 2.10, 3.00, 3.00 }; 
		double [] darr6 = { e,    e,    e,    e,    e,    e    };
		double [] garr6 = { 1.0,  1.0,  1.0,  1.0,  1.0,  1.0  };
		String [] iarr6 = { "b",  "n",  "n",  "b",  "n",  "n"  };
		theRiffs[6] = new riff(parr6.length, parr6, darr6, garr6, iarr6);

		// riff 7
		double [] parr7 = { 1.10, 2.00, 2.00, 2.07 };
		double [] darr7 = { e,    e,    e,    dq   };
		double [] garr7 = { 1.0,  1.0,  1.0,  1.0  };
		String [] iarr7 = { "b",  "n",  "n",  "v"  };
		theRiffs[7] = new riff(parr7.length, parr7, darr7, garr7, iarr7);

		// riff 8
		double [] parr8 = { 3.00, 2.10, 2.07, 2.05, 2.03, 2.00, 1.10, 2.00 };
		double [] darr8 = { e,    s,    s,    s,    s,    e,    e,    e    };
		double [] garr8 = { 1.0,  1.0,  1.0,  1.0,  1.0,  1.0,  1.0,  1.0  };
		String [] iarr8 = { "b",  "n",  "n",  "n",  "n",  "n",  "n",  "n", };
		theRiffs[8] = new riff(parr8.length, parr8, darr8, garr8, iarr8);

		// riff 9
		double [] parr9 = { 3.00, 3.02, 3.03, 3.00, 2.10, 2.07, 2.05, 2.03, 2.00, 1.10, 2.00, 2.03 };
		double [] darr9 = { s, s, s, s, s, s, s, s, s, s, s, s };
		double [] garr9 = { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 };
		String [] iarr9 = { "n", "n", "n", "n", "n", "n", "n", "n", "n", "n", "n", "n" };
		theRiffs[9] = new riff(parr9.length, parr9, darr9, garr9, iarr9);

		// riff 10
		double [] parr10 = { 2.00, 2.03, 2.00, 1.10, 1.07, 1.10 };
		double [] darr10 = { e,    e,    e,    e,    e,    e    };
		double [] garr10 = { 1.0,  1.0,  1.0,  1.0,  1.0,  1.0  };
		String [] iarr10 = { "n",  "n",  "n",  "v",  "n",  "n"  };
		theRiffs[10] = new riff(parr10.length, parr10, darr10, garr10, iarr10);
	}
		
	public void godaddy(float basenote, float beat) {
		float st, rst, pch, pch2, d, rd;
		int rdex; // for choosing a riff
		double pvar = 0.002; // pitch variance (oct.pc)
		double stvar = 0.01; // timing variance
		int i;

		// choose a riff!
		rdex = (int)(Math.random() * (double)theRiffs.length);
		st = (float)0.0;
		d = (float)0.0;
		for (i = 0; i < theRiffs[rdex].numnotes; i++) {
			// get pitch
			pch = basenote + (float)(theRiffs[rdex].pitches[i]);
			pch = pch + (float)(Math.random() * pvar);
			
			// get dur -- if the dur is 0, the note is stacked
			if (theRiffs[rdex].durs[i] != 0) d = beat * (float)theRiffs[rdex].durs[i];
			else st = st - d; // set st back to stack the note
			rst = st + (float)(Math.random() * stvar);
			rd = d * (float)theRiffs[rdex].gaps[i];

			// write out the note!
			if (theRiffs[rdex].inflects[i] == "n") {
				outlet(0, "rtcmix START1 " + rst + " " + rd + " " + pch + " 1.0 1.0 100.0 0.1 6.00 0.0 1.0 20000.0 9.0");
			}
			else if (theRiffs[rdex].inflects[i] == "v") {
				outlet(0, "rtcmix makegen 2 10 1000 1");
				outlet(0, "rtcmix makegen 3 24 1000 0 1 1 1");
				outlet(0, "rtcmix VSTART1 " + rst + " " + rd + " " + pch + " 1.0 1.0 100.0 0.1 6.00 0.0 1.0 20000.0 9.0 5.0 9.0 3.0");
			}
			else if (theRiffs[rdex].inflects[i] == "b") {
				float t1, t2, t3, t4, v1, v2, v3, v4;

				t2 = (float)(Math.random()*0.3 + 0.2);
				t1 = (float)(Math.random()*(double)t2);
				t3 = (float)(Math.random()*0.3 + 0.5);
				t4 = (float)(Math.random()*(1.0-(double)t3) + (double)t3);
				if (Math.random() >= 0.5) {
					v1 = (float)(Math.random()*0.3);
					v2 = (float)(Math.random()*0.1);
					v3 = (float)(1.0 - Math.random()*0.3);
					v4 = (float)(1.0 - Math.random()*0.1);
				}
				else {
					v1 = (float)(1.0 - Math.random()*0.3);
					v2 = (float)(1.0 - Math.random()*0.1);
					v3 = (float)(Math.random()*0.3);
					v4 = (float)(Math.random()*0.1);
				}
				outlet(0, "rtcmix makegen 2 24 1000 0 0 " + t1 + " " + v1 + " " + t2 + " " + v2 + " " + t3 + " " + v3 + " "+ t4 + " " + v4 + " 1 1");
				outlet(0, "rtcmix START1 " + rst + " " + 0.0 + " " + pch + " 1.0 1.0 100.0 0.1 6.00 0.0 1.0 20000.0 9.0");
				pch2 = pch + (float)0.02;
				outlet(0, "rtcmix BEND1 " + rst + " " + rd + " " + pch + " " + pch2 + " 2 1.0 1.0 100.0 0.1 6.00 0.0 1.0 20000.0");
			}

			st = st + d;
		}

		outlet(0, "rtcmix MAXBANG " + st);
	}


	class riff {
	// this class holds data in 4 arrays: pitches[], durs[], inflects[], gaps[]
	//		pitches[] are pitch-offsets (oct.pc) of a base note
	//		durs[] are duration multipliers of a base beat
	// 	inflects[] are strings "n", "b", "v" (normal/bend/vibrato)
	// 	gaps[] are duration multipliers for notes shorter than the dur
	//	also it holds how many notes in each riff
		float [] pitches;
		float [] durs;
		float [] gaps;
		String [] inflects;
		int numnotes;

		public riff(int nnotes, double [] pchs, double [] ds, double [] gs, String [] infs) {
			int i;

			numnotes = nnotes;
			pitches = new float[nnotes];
			durs = new float[nnotes];
			gaps = new float[nnotes];
			inflects = new String[nnotes];
			// load 'em up
			for (i = 0; i < nnotes; i++) {
				pitches[i] = (float)pchs[i];
				durs[i] = (float)ds[i];
				gaps[i] = (float)gs[i];
				inflects[i] = infs[i];
			}
		}
	}
}

